--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- emChangeDress
-- 自動お色直し
-- Version 0.01
-- written by エミファ
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local emChangeDress = {};
_G.emChangeDress = emChangeDress;

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- バージョンなど
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local EMCD_MYNAME = "emChangeDress";
local EMCD_VERSION = "emChangeDress Version 0.01";
local EMCD_VER_AM = "v0.01";
local EMCD_ICON = "Interface\\Addons\\emChangeDress\\Textures\\emcd_normal.png"
local EMCD_CATEGORY = "Miscellaneous";
local EMCD_DIR = "Interface/Addons/emChangeDress/";
local EMCD_EXT = ".lua";
local EMCD_PR_LOCALE = "locales/emChangeDress.";
local EMCD_LOADED = false;
local EMCD_LOADEDSTRING = "emChangeDress 0.01 loaded.";
local EMCD_INTERVAL_LEN = 4;
EMCD_STRING = {};

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 着替えパターン数、スロット数
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local EMCD_PTN_FIRST  = 1;
local EMCD_PTN_LAST   = 4;
local EMCD_PTN_ZERO   = 0;	-- 実際の着脱なし見た目のみ
local EMCD_SLOT_NONE  = 0;	-- 選択スロットなし(やっぱり何もしない)
local EMCD_SLOT_FIRST = 1;	
local EMCD_SLOT_LAST  = 17;
local g_emcdPtn       = EMCD_PTN_FIRST;
local g_emcdSlotCnt   = EMCD_SLOT_NONE;	

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- プロファイル関連
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local g_emcdChar = "";
local g_emcdRealm = "";
local EMCD_DEF_INTERVAL = 0.5;
local EMCD_NIN_INTERVAL = 0.0;
local EMCD_MAX_INTERVAL = 1.0;
local EMCD_KEY_INTERVAL = "Interval";	-- インターバル
local EMCD_DEF_DURACHK = true;			-- デフォルトでは耐久チェックをする
local EMCD_KEY_DURACHK = "DuraCheck";	-- 耐久チェックをするか？
local EMCD_DEF_POSX = 300;
local EMCD_DEF_POSY = 300;
local EMCD_KEY_POSX = "PosX";
local EMCD_KEY_POSY = "PosY";

local EMCD_KEY_PTNNAME = "PatternName";	-- 耐久チェックをするか？
local EMCD_KEY_HEAD 	= 1;			-- 頭
local EMCD_KEY_HAND 	= 2;			-- 手
local EMCD_KEY_FOOT 	= 3;			-- 足
local EMCD_KEY_CHEST 	= 4;			-- 胸
local EMCD_KEY_LEG 		= 5;			-- 脚
local EMCD_KEY_CAPE 	= 6;			-- マント
local EMCD_KEY_BELT 	= 7;			-- ベルト
local EMCD_KEY_SHOULDER = 8;			-- 肩
local EMCD_KEY_NECK 	= 9;			-- 首
local EMCD_KEY_AMMO 	= 10;			-- 弾
local EMCD_KEY_RANGE 	= 11;			-- 遠隔
local EMCD_KEY_RINGR 	= 12;			-- 指輪（右）
local EMCD_KEY_RINGL 	= 13;			-- 指輪(左)	
local EMCD_KEY_EARR 	= 14;			-- 耳（右）
local EMCD_KEY_EARL 	= 15;			-- 耳（左）
local EMCD_KEY_MAINARM 	= 16;			-- 右手
local EMCD_KEY_OFFHAND 	= 17;			-- 左手
local EMCD_DEF_SHOWN 	= true;			-- デフォルトでは装備表示する
local EMCD_KEY_SHOWN 	= "Shown";		-- 表示
local EMCD_KEY_ITEMNAME	= "ItemName";	-- 装備名
local EMCD_KEY_DURA 	= "Dura";		-- 耐久

local EMCD_SHOWNBLOCK = {"Head", "Hands", "Feet", "Chest", "Legs", "Back", "Waist", "Shoulder"};

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- バッグスロットサーチ範囲
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local EMCD_SEARCH_START = 1;
local EMCD_SEARCH_END   = 180;
local g_emcdSearchStart = EMCD_SEARCH_START;	-- 耐久チェック時のサーチ開始位置(可変)

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- カウンタ
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local g_emcdRemaining = EMCD_DEF_INTERVAL;

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- やってみたかっただけの多言語対応(多国で動くかまでは知らない)
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:LoadLanguage()
	local lang = string.sub( GetLanguage():upper(), 1, 2 );
	local localeFileName = EMCD_DIR..EMCD_PR_LOCALE..string.upper(lang)..EMCD_EXT;
	local func, err = loadfile(localeFileName);
	if (err) then
		dofile( EMCD_DIR..EMCD_PR_LOCALE.."EN"..EMCD_EXT );
	else
		dofile( localeFileName );
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 最初に言語リソースを読み込んでおく
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
emChangeDress:LoadLanguage();

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- スラッシュコマンド
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
SLASH_emChangeDress1 = "/emChangeDress";
SLASH_emChangeDress2 = "/emcd";
SlashCmdList[ EMCD_MYNAME ] = function(editBox, msg)
	msg = string.lower(msg)
	if (msg == "0") then
		emChangeDress:CustomUndress();
	elseif (msg == "1") then
		emChangeDress:ChangeDress(1);
	elseif (msg == "2") then
		emChangeDress:ChangeDress(2);
	elseif (msg == "3") then
		emChangeDress:ChangeDress(3);
	elseif (msg == "4") then
		emChangeDress:ChangeDress(4);
	elseif (msg == "undress") then
		emChangeDress:Undress();
	elseif (msg == "mini") then
		emChangeDress:OnMiniConfigToggle();
	else
		if ( g_emcdSlotCnt == EMCD_SLOT_NONE ) then
			if ( emcdConfig_Frame:IsVisible() ) then
				-- 表示されてれば消す
				emcdConfig_Frame:Hide();
			else
				-- フレームを表示
				emcdConfig_Frame:Show();
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage( EMCD_STRING["NOOPEN"] );
		end
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 警告
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:Warning(str)
	DEFAULT_CHAT_FRAME:AddMessage( str, 0.93, 0.11, 0.14 );
	SendWarningMsg( str );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 設定読み込み
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:LoadProfile()
	-- プロファイルそのものがなければつくる
	if (not EMCD_PROFILES) then
		EMCD_PROFILES={};
	end
	
	-- サーバごとのプロファイルがなければつくる
	g_emcdRealm = GetCurrentRealm();
	if (not EMCD_PROFILES[g_emcdRealm]) then
		EMCD_PROFILES[g_emcdRealm]={};
	end
	
	-- キャラごとのプロファイルがなければつくる
	local class, subClass = UnitClass("player");
	local playerName = UnitName("player");
	g_emcdChar = class..playerName;

	if (not EMCD_PROFILES[g_emcdRealm][g_emcdChar]) then
		EMCD_PROFILES[g_emcdRealm][g_emcdChar] = {};
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_INTERVAL] 	= EMCD_DEF_INTERVAL;
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_DURACHK] 	= EMCD_DEF_DURACHK;
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_POSX] 		= EMCD_DEF_POSX;
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_POSY] 		= EMCD_DEF_POSY;
		
		-- 各パターン
		local ptn = 0;
		local slot = 0;
		local shownSlot = 0;
		for ptn = EMCD_PTN_ZERO, EMCD_PTN_LAST do
			EMCD_PROFILES[g_emcdRealm][g_emcdChar][ptn] = {};
			EMCD_PROFILES[g_emcdRealm][g_emcdChar][ptn][EMCD_KEY_PTNNAME] = EMCD_STRING["UNDEFINED"];
			
			-- 各スロット
			for slot = EMCD_SLOT_FIRST, EMCD_SLOT_LAST do
				EMCD_PROFILES[g_emcdRealm][g_emcdChar][ptn][slot] = {};
				EMCD_PROFILES[g_emcdRealm][g_emcdChar][ptn][slot][EMCD_KEY_ITEMNAME] = "";		-- 装備名
				EMCD_PROFILES[g_emcdRealm][g_emcdChar][ptn][slot][EMCD_KEY_DURA] = 0;		-- 耐久
			end
			
			-- 表示
			EMCD_PROFILES[g_emcdRealm][g_emcdChar][ptn][EMCD_KEY_SHOWN] = {};
			for shownSlot = EMCD_KEY_HEAD, EMCD_KEY_SHOULDER do
				EMCD_PROFILES[g_emcdRealm][g_emcdChar][ptn][EMCD_KEY_SHOWN][shownSlot] = EMCD_DEF_SHOWN;	-- 表示
			end
		end
		-- 一部表示の名称だけ特別
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_PTN_ZERO][EMCD_KEY_PTNNAME] = EMCD_STRING["AVENTURE"];
	end

	-- インターバルの範囲チェック
	if ( EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_INTERVAL] < EMCD_NIN_INTERVAL ) then
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_INTERVAL] = EMCD_NIN_INTERVAL;
	end
	if ( EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_INTERVAL] > EMCD_MAX_INTERVAL ) then
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_INTERVAL] = EMCD_MAX_INTERVAL;
	end
	
	EMCD_LOADED = true;
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- イベント登録
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnLoad(this)
	emChangeDress_Frame:RegisterEvent( "VARIABLES_LOADED" );
	emChangeDress_Frame:RegisterEvent( "LOADING_END" );
	SaveVariables( "EMCD_PROFILES" );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- イベントハンドラ
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnEvent( event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 )
	self[event]( self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- ロード時
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:VARIABLES_LOADED()
	DEFAULT_CHAT_FRAME:AddMessage( EMCD_LOADEDSTRING );
	emChangeDress:RegistAddonManager();
end
function emChangeDress:LOADING_END()
	EMCD_LOADED = false;
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 何かするときの事前処理
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:PriorProcessing()
	if ( EMCD_LOADED == false ) then
		emChangeDress:LoadProfile();
	end

	if ( emcdConfig_Frame:IsVisible() ) then
		-- 設定画面が表示されてれば消す
		emcdConfig_Frame:Hide();
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 一部非表示(外部から呼ばれる)
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:CustomUndress()
	emChangeDress:PriorProcessing();

	for i = EMCD_KEY_HEAD, EMCD_KEY_SHOULDER do
		SetEquipItemShown( i - 1, EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_PTN_ZERO][EMCD_KEY_SHOWN][i] );
		_G["Equip" .. EMCD_SHOWNBLOCK[i] .. "SlotShowCheckButton"]:SetChecked( GetEquipItemShown( i - 1 ) );
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- すべて非表示(外部から呼ばれる)
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:Undress()
	emChangeDress:PriorProcessing();

	for i = EMCD_KEY_HEAD, EMCD_KEY_SHOULDER do
		SetEquipItemShown( i - 1, false );
		_G["Equip" .. EMCD_SHOWNBLOCK[i] .. "SlotShowCheckButton"]:SetChecked( GetEquipItemShown( i - 1 ) );
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- お色直し(外部から呼ばれる)
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:ChangeDress(ptn)
	emChangeDress:PriorProcessing();

	-- 設定確認
	local settingName = EMCD_PROFILES[g_emcdRealm][g_emcdChar][ptn][EMCD_KEY_PTNNAME];
	if ( emChangeDress:ChkSettingName( settingName ) ) then
		-- タイマー処理に任せる
		g_emcdPtn = ptn;
		g_emcdSlotCnt = EMCD_SLOT_FIRST;
		g_emcdSearchStart = EMCD_SEARCH_START;
		DEFAULT_CHAT_FRAME:AddMessage( EMCD_STRING["EQUIP_START"] );
	else
		-- 設定名称未設定
		emChangeDress:Warning( EMCD_STRING["NAMEERR"] );
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- タイマー処理
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnUpdate( elapsed )
	if ( EMCD_LOADED == false ) then
		-- 初期化前は何もしない
		return;
	end
	
	if ( g_emcdSlotCnt == EMCD_SLOT_NONE ) then
		-- 装備切替の必要なし
		return;
	end

	-- 周期チェック
	g_emcdRemaining = g_emcdRemaining - elapsed;
	if ( g_emcdRemaining > 0 ) then
		-- 周期が過ぎていないのでなにもせずに返す
		return;
	end
	
	-- 装備変更
	if ( g_emcdSlotCnt > EMCD_SLOT_LAST ) then
		-- 着脱処理が完了していれば、カウンタをリセットする
		g_emcdSlotCnt = EMCD_SLOT_NONE;
		g_emcdSearchStart = EMCD_SEARCH_START;
		DEFAULT_CHAT_FRAME:AddMessage( EMCD_STRING["EQUIP_END"] );
	else
		-- 脱ぐかきるかする(一回でも着脱したら抜けて次の処理を待つ
		emChangeDress:ChangeSlot();
	end	
	
	-- 周期リセット
	g_emcdRemaining = EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_INTERVAL];
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- バンヘルディー対策
-- (A)とか(B)とかがあると動かなくなるので最後の3文字だけ取り払う
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function AntivahtosItemName(rawName)
	-- バンヘルディー対策
	-- (A)とか(B)とかがあると動かなくなるので最後の3文字だけ取り払う
	if ( rawName == nil ) then
		return nil;
	else
		if ( ( string.find( rawName, "(A)" ) ) or ( string.find( rawName, "(B)" ) ) ) then
			local len = string.len( rawName );
			local name = string.sub( rawName, 1, len - 3 ); 
			return name;
		else
			return rawName;
		end
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 装備着脱
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:ChangeSlot()
	-- ローカル参照にすると速くなるらしい
	local emcdDuraChk = EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_DURACHK];
	local emcdItemName = EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][g_emcdSlotCnt][EMCD_KEY_ITEMNAME];
	local emcdItemDura = EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][g_emcdSlotCnt][EMCD_KEY_DURA];
	local emcdShown = EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][g_emcdSlotCnt];
	local j = 0;
	local needWait = false;	-- なんかの待ちが必要な処理をしたら真
	
	-- 装備の表示非表示
	if ( ( g_emcdSlotCnt >= EMCD_KEY_HEAD ) and ( g_emcdSlotCnt <= EMCD_KEY_SHOULDER ) ) then
		-- 装備表示が必要な箇所であれば
		if ( GetEquipItemShown( g_emcdSlotCnt - 1 ) ~= emcdShown ) then
			-- 装備状態を変える必要あり
			SetEquipItemShown( g_emcdSlotCnt - 1, emcdShown );
			_G["Equip" .. EMCD_SHOWNBLOCK[g_emcdSlotCnt] .. "SlotShowCheckButton"]:SetChecked( GetEquipItemShown( g_emcdSlotCnt - 1 ) );
			needWait = true;
		end
	end

	-- 現スロットのアイテム名と耐久を取得
	-- GetInventoryItemDurableはインデックスが１からではなく0始まりらしいので-1
	local curD, maxD, itemName, curDfull, maxDfull = GetInventoryItemDurable( "player", g_emcdSlotCnt -1 );

	local equipedItem = AntivahtosItemName(itemName);
	if ( equipedItem == nil ) then
		equipedItem = "";
	end
	
	-- 現スロットの装備とデータの装備すべきアイテムを比較
	local sameEquip = false;
	if ( equipedItem == emcdItemName ) then
		if ( emcdDuraChk ) then
			-- 耐久チェックもする
			if ( maxD == emcdItemDura ) then
				sameEquip = true;
			end
		else
			-- 耐久は気にしないので名前が一致すれば同じアイテムとする
			sameEquip = true;
		end
	end

	-- 比較結果によって着脱
	if ( sameEquip == false ) then
		-- 装備変更の必要あり
		if ( emcdItemName == "" ) then
			-- セーブデータで空白指定されていれば
			if ( equipedItem ~= "" ) then
				-- 現在何か着ていれば脱ぐ
				EquipItem( g_emcdSlotCnt );
				needWait = true;
			end
		else
			-- とりあえずセーブデータで指定された装備と同名のものを探して着る
			for j = g_emcdSearchStart, EMCD_SEARCH_END do
				local slot,icon,name = GetBagItemInfo(j);
				if ( string.find( name, emcdItemName ) ) then
					-- 同一名称アイテムならとりあえず着てみる
					-- その後の判断は、次回のOnUpdateでやる
					EquipItem( g_emcdSlotCnt, slot );
					needWait = true;
					if ( emcdDuraChk ) then
						-- 耐久チェックありの時は、次のサーチ位置を指定する
						g_emcdSearchStart = j + 1;
						return;
					else
						-- なしの時は次の部位へ
						break;
					end
				end
			end
			-- バッグに指定アイテムがない場合、しょうがないから次へ進む
		end
	end
	-- 耐久チェックありの時で装備をつけたとき以外は次へ進む
	g_emcdSlotCnt = g_emcdSlotCnt + 1;
	if ( emcdDuraChk ) then
		g_emcdSearchStart = EMCD_SEARCH_START;
	end
	
	-- とくにwaitが必要の処理をしていないときは再帰する
	if ( ( needWait == false ) and ( g_emcdSlotCnt > EMCD_SLOT_NONE ) and ( g_emcdSlotCnt <= EMCD_SLOT_LAST ) ) then
		emChangeDress:ChangeSlot();
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- インターバルのみ表示
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:IntervalShow()
	local strInterval = tostring( emcdSlider:GetValue() );
	emcdTxtInterval:SetText( string.format( EMCD_STRING["INTERVAL"], string.sub( strInterval, 1, EMCD_INTERVAL_LEN ) ) );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- アイテム表示名称
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:GetViewName(ptn, idx)
	local itemName = EMCD_PROFILES[g_emcdRealm][g_emcdChar][ptn][idx][EMCD_KEY_ITEMNAME];
	local itemDura = EMCD_PROFILES[g_emcdRealm][g_emcdChar][ptn][idx][EMCD_KEY_DURA];
	local viewName = "";
	if ( itemName ~= "" ) then
		viewName = itemName .. "("..itemDura..")";
	end
	return viewName;
end
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 設定画面表示
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnShow()
	if ( EMCD_LOADED == false ) then
		emChangeDress:LoadProfile();
	end
	
	-- ラベル
	emcdTxtVer:SetText( EMCD_VERSION );
	emcdTxtShare:SetText( EMCD_STRING["SHAREITEM"] );
	emcdTxtDuraCheck:SetText( EMCD_STRING["DURACHECK"] );

	-- 耐久チェック
	emcdDuraCheck:SetChecked( EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_DURACHK] );

	-- スライダー
	emcdSlider.loading=1;
	emcdSlider:SetValueStepMode( "FLOAT" );
	emcdSlider:SetMinMaxValues( EMCD_NIN_INTERVAL, EMCD_MAX_INTERVAL );
	emcdSlider.loading=0;
	emcdSlider:SetValue( EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_INTERVAL] );
	emChangeDress:IntervalShow();

	-- 装備
	emcdTxt1:SetText( emChangeDress:GetViewName( g_emcdPtn, 1 ) );
	emcdTxt2:SetText( emChangeDress:GetViewName( g_emcdPtn, 2 ) );
	emcdTxt3:SetText( emChangeDress:GetViewName( g_emcdPtn, 3 ) );
	emcdTxt4:SetText( emChangeDress:GetViewName( g_emcdPtn, 4 ) );
	emcdTxt5:SetText( emChangeDress:GetViewName( g_emcdPtn, 5 ) );
	emcdTxt6:SetText( emChangeDress:GetViewName( g_emcdPtn, 6 ) );
	emcdTxt7:SetText( emChangeDress:GetViewName( g_emcdPtn, 7 ) );
	emcdTxt8:SetText( emChangeDress:GetViewName( g_emcdPtn, 8 ) );
	emcdTxt9:SetText( emChangeDress:GetViewName( g_emcdPtn, 9 ) );
	emcdTxt10:SetText( emChangeDress:GetViewName( g_emcdPtn, 10 ) );
	emcdTxt11:SetText( emChangeDress:GetViewName( g_emcdPtn, 11 ) );
	emcdTxt12:SetText( emChangeDress:GetViewName( g_emcdPtn, 12 ) );
	emcdTxt13:SetText( emChangeDress:GetViewName( g_emcdPtn, 13 ) );
	emcdTxt14:SetText( emChangeDress:GetViewName( g_emcdPtn, 14 ) );
	emcdTxt15:SetText( emChangeDress:GetViewName( g_emcdPtn, 15 ) );
	emcdTxt16:SetText( emChangeDress:GetViewName( g_emcdPtn, 16 ) );
	emcdTxt17:SetText( emChangeDress:GetViewName( g_emcdPtn, 17 ) );

	-- 表示
	emcdChkShownHead:SetChecked( EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_HEAD] );
	emcdChkShownHand:SetChecked( EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_HAND] );
	emcdChkShownFoot:SetChecked( EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_FOOT] );
	emcdChkShownChest:SetChecked( EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_CHEST] );
	emcdChkShownLeg:SetChecked( EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_LEG] );
	emcdChkShownCape:SetChecked( EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_CAPE] );
	emcdChkShownBelt:SetChecked( EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_BELT] );
	emcdChkShownShoulder:SetChecked( EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_SHOULDER] );
	
	emcdTxtHead:SetText( EMCD_STRING["SH_HEAD"] );
	emcdTxtHand:SetText( EMCD_STRING["SH_HAND"] );
	emcdTxtFoot:SetText( EMCD_STRING["SH_FOOT"] );
	emcdTxtChest:SetText( EMCD_STRING["SH_CHEST"] );
	emcdTxtLeg:SetText( EMCD_STRING["SH_LEG"] );
	emcdTxtCape:SetText( EMCD_STRING["SH_CAPE"] );
	emcdTxtBelt:SetText( EMCD_STRING["SH_BELT"] );
	emcdTxtShoulder:SetText( EMCD_STRING["SH_SHOULDER"] );

	emcdTxtShown:SetText( EMCD_STRING["SHOWN"] );
	
	-- パターン名
	emcdEdtSetname:SetText( EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_PTNNAME] );

	-- セーブボタン
	emcdBtnSave:SetText( EMCD_STRING["SAVE"] );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 装備しているアイテム名を取得
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:GetInventoryItemName(idx)
	-- GetInventoryItemDurableはインデックスが１からではなく0始まりらしいので-1
	local curD, maxD, itemName, curDfull, maxDfull = GetInventoryItemDurable( "player", idx -1 );
	
	return AntivahtosItemName(itemName);
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 名称審査
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:ChkSettingName(settingName)
	if ( ( settingName ~= "" ) and ( settingName ~= EMCD_STRING["UNDEFINED"] ) ) then
		return true;
	else
		return false;
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 設定保存
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnSave()

	local settingName = emcdEdtSetname:GetText();
	if ( emChangeDress:ChkSettingName( settingName ) == false ) then
		emChangeDress:Warning( EMCD_STRING["NAMEERR"] );
		return;
	end

	-- パターン名
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_PTNNAME] = emcdEdtSetname:GetText();
	

	-- 耐久チェック
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_DURACHK] = emcdDuraCheck:IsChecked();

	-- インターバル
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_INTERVAL] = emcdSlider:GetValue();
	
	-- 装備
	local slot;
	if ( g_emcdPtn > EMCD_PTN_ZERO ) then
		for slot = EMCD_SLOT_FIRST, EMCD_SLOT_LAST do
			emChangeDress:SaveItemName( slot );
		end 
	end

	-- 表示
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_HEAD] = emcdChkShownHead:IsChecked();
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_HAND] = emcdChkShownHand:IsChecked();
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_FOOT] = emcdChkShownFoot:IsChecked();
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_CHEST] = emcdChkShownChest:IsChecked();
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_LEG] = emcdChkShownLeg:IsChecked();
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_CAPE] = emcdChkShownCape:IsChecked();
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_BELT] = emcdChkShownBelt:IsChecked();
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][EMCD_KEY_SHOWN][EMCD_KEY_SHOULDER] = emcdChkShownShoulder:IsChecked();
	
	SaveVariables( "EMCD_PROFILES" );

	emChangeDress:OnShow();
	emChangeDress:OnMiniConfigLoad();
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- アイテム名と耐久の保存
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:SaveItemName( idx )
	local equipedItem = "";
	-- GetInventoryItemDurableはインデックスが１からではなく0始まりらしいので-1
	local curD, maxD, itemName, curDfull, maxDfull = GetInventoryItemDurable( "player", idx -1 );

	local equipedItem = AntivahtosItemName(itemName);

	if (equipedItem ~= nil ) then
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][idx][EMCD_KEY_ITEMNAME] = equipedItem;
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][idx][EMCD_KEY_DURA] = maxD;
	else
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][idx][EMCD_KEY_ITEMNAME] = "";
		EMCD_PROFILES[g_emcdRealm][g_emcdChar][g_emcdPtn][idx][EMCD_KEY_DURA] = 0;
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 左矢印
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnLeftArrow()
	g_emcdPtn = g_emcdPtn - 1;
	if ( g_emcdPtn < EMCD_PTN_ZERO ) then
		g_emcdPtn = EMCD_PTN_LAST;
	end
	emChangeDress:OnShow();
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 右矢印
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnRightArrow()
	g_emcdPtn = g_emcdPtn + 1;
	if ( g_emcdPtn > EMCD_PTN_LAST ) then
		g_emcdPtn = EMCD_PTN_ZERO;
	end
	emChangeDress:OnShow();
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- ミニコンフィグの位置
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnMiniConfigSavePos()
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_POSX],
	EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_POSY] = emcdMiniConfig:GetPos();
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- ミニコンフィグボタン表示／非表示
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnMiniConfigButtonShow(btn, idx)
	local settingName = EMCD_PROFILES[g_emcdRealm][g_emcdChar][idx][EMCD_KEY_PTNNAME];
	if ( emChangeDress:ChkSettingName( settingName ) ) then
		btn:Show();
		btn:SetText( settingName );
	else
		btn:Hide();
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- ミニコンフィグロード
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnMiniConfigLoad()
	if ( EMCD_LOADED == false ) then
		emChangeDress:LoadProfile();
	end

	local scale = GetUIScale();
	local x = EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_POSX] / scale;
	local y = EMCD_PROFILES[g_emcdRealm][g_emcdChar][EMCD_KEY_POSY] / scale;
	emcdMiniConfig:ClearAllAnchors()
	emcdMiniConfig:SetAnchor("TOPLEFT","TOPLEFT","UIParent",x, y);
	
	emChangeDress:OnMiniConfigButtonShow( emcdBtnMini1, 1 );
	emChangeDress:OnMiniConfigButtonShow( emcdBtnMini2, 2 );
	emChangeDress:OnMiniConfigButtonShow( emcdBtnMini3, 3 );
	emChangeDress:OnMiniConfigButtonShow( emcdBtnMini4, 4 );
	
	emcdBtnMiniCustomUndress:SetText( EMCD_PROFILES[g_emcdRealm][g_emcdChar][0][EMCD_KEY_PTNNAME] );
	emcdBtnMiniUndress:SetText( EMCD_STRING["UNDRESS"] );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- ミニコンフィグロード
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:OnMiniConfigToggle()
	if ( emcdMiniConfig:IsVisible() ) then
		-- 表示されてれば消す
		emcdMiniConfig:Hide();
	else
		-- フレームを表示
		emcdMiniConfig:Show();
	end
end
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- AddonManagerへの登録
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emChangeDress:RegistAddonManager()
	if (AddonManager) then
		local addon = {
			name = EMCD_MYNAME,
			version = EMCD_VER_AM,
			author = EMCD_STRING["AM_AUTHOR"],
			description = EMCD_STRING["AM_DISC"],
  	 		icon = EMCD_ICON,
			category = EMCD_CATEGORY,
			configFrame = emcdConfig_Frame, 
			slashCommands = SLASH_emChangeDress2,
			miniButton = emcdAddonManagerMiniButton,
		};
		if AddonManager.RegisterAddonTable then
			AddonManager.RegisterAddonTable(addon);
		else
			AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, addon.configFrame, addon.slashCommand, addon.miniButton, addon.version, addon.author, addon.onClickScript);
		end
	end
end
